package com.jkcredit.traffic.record.config;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;

import java.util.concurrent.*;

/**
 * @author xusonglin
 * @version V1.0
 **/
//@Configuration
//@EnableAsync
public class ThreadPoolConfig {
    @Value("${thread.pool.coreSize}")
    private Integer coreSize;

    @Value("${thread.pool.maximumPoolSize}")
    private Integer maximumPoolSize;

    @Value("${thread.pool.queueSize}")
    private Integer queueSize;

    @Bean("mainThreadPoolExecutor")
    @Qualifier("executor")
    public ThreadPoolExecutor mainThreadPoolExecutor() {
        LinkedBlockingDeque<Runnable> deque = new LinkedBlockingDeque<>(queueSize);

        return new ThreadPoolExecutor(coreSize,
                maximumPoolSize, 10,
                TimeUnit.MINUTES, deque);
    }

    @Bean
    public ExecutorService executorService() {
        return Executors.newWorkStealingPool();
    }

}
