package com.jkcredit.traffic.record.task;

import com.jkcredit.traffic.record.service.TrafficRecordsAnalyseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Component
@Slf4j
public class PushRecordsTask {
    @Value("${originalRecords.path}")
    private String originalRecordsPath;
    @Autowired
    TrafficRecordsAnalyseService trafficRecordsAnalyseService;

    @Scheduled(cron = "0 0 18 * * ?")
    public void push() {
        trafficRecordsAnalyseService.pushTrafficRecords(originalRecordsPath);
    }
}
