package com.jkcredit.traffic.record.util;

/**
 * @author xusonglin
 * @version V1.0
 **/
public class DivideDataUtil {
    /**
     * 出行次数
     * 0-100/5/20；100-300/10/20；300-600/20/15；600-1000/50/8；1000以上/1
     *
     * @param exTimesCount 出行次数
     * @return 脱敏后出行次数区间
     */
    public static String divideExTimesCount(String exTimesCount) {
        String result = "A";
        int times = Integer.parseInt(exTimesCount.split("\\.")[0]);

        if (times < 100) {
            result = result + (times / 5 + 1);
        } else if (times < 300) {
            result = result + ((times - 100) / 10 + 1 + 20);
        } else if (times < 600) {
            result = result + ((times - 300) / 20 + 1 + 20 + 20);
        } else if (times < 1000) {
            result = result + ((times - 600) / 50 + 1 + 20 + 20 + 15);
        } else {
            result = result + (1 + 20 + 20 + 15 + 8);
        }
        return result;
    }

    /**
     * 出行消费总金额，第一个区间是0；第二个区间：(0,2000],第三个区间：(2000,4000]
     *
     * @param sumFee 0/1; 0-10000/2000/5; 10000-100000/3000/30; 100000-500000/16000/25; 500000-1000000/25000/20; 1000000-8000000/500000/14; 8000000以上/1
     * @return 脱敏后出行消费总金额区间
     */
    public static String divideSumFee(String sumFee) {
        String result = "B";
        long fee = Long.parseLong(sumFee.split("\\.")[0]);
        if (fee == 0) {
            result = result + "0";
            return result;
        }
        fee = fee - 1;
        if (fee < 10000) {
            result = result + (fee / 2000 + 1);
        } else if (fee < 100000) {
            result = result + ((fee - 10000) / 3000 + 1 + 5);
        } else if (fee <= 500000) {
            result = result + ((fee - 100000) / 16000 + 1 + 5 + 30);
        } else if (fee <= 1000000) {
            result = result + ((fee - 500000) / 25000 + 1 + 5 + 30 + 25);
        } else if (fee <= 8000000) {
            result = result + ((fee - 1000000) / 500000 + 1 + 5 + 30 + 25 + 20);
        } else {
            result = result + (1 + 1 + 5 + 30 + 25 + 20 + 14);
        }
        return result;
    }

    /**
     * 出行总时长
     *
     * @param sumTravelTime 0-3600/1800/2; 3600-68400/3600/18; 68400-608400/36000/15; 608400-2595600/86400/23; 2595600以上/1
     * @return 脱敏后出行总时长区间
     */
    public static String divideSumTravelTime(String sumTravelTime) {
        String result = "C";
        long travelTime = Long.parseLong(sumTravelTime.split("\\.")[0]);
        if (travelTime < 3600) {
            result = result + (travelTime / 1800 + 1);
        } else if (travelTime < 68400) {
            result = result + ((travelTime - 3600) / 3600 + 1 + 2);
        } else if (travelTime < 608400) {
            result = result + ((travelTime - 68400) / 36000 + 1 + 2 + 18);
        } else if (travelTime < 2595600) {
            result = result + ((travelTime - 608400) / 86400 + 1 + 2 + 18 + 15);
        } else {
            result = result + (1 + 2 + 18 + 15 + 23);
        }
        return result;
    }

    /**
     * 最长出行时长
     *
     * @param maxTravelTime 0-12000/1000/12; 12000-612000/20000/30; 612000以上/1个
     * @return 脱敏后最长出行时长区间
     */
    public static String divideMaxTravelTime(String maxTravelTime) {
        String result = "D";
        long travelTime = Long.parseLong(maxTravelTime.split("\\.")[0]);
        if (travelTime < 12000) {
            result = result + (travelTime / 1000 + 1);
        } else if (travelTime < 612000) {
            result = result + ((travelTime - 12000) / 20000 + 1 + 12);
        } else {
            result = result + (1 + 12 + 30);
        }
        return result;
    }

    /**
     * 出行总里程
     *
     * @param sumFeeMileage 0-200000/50000/4; 200000-1000000/100000/8; 1000000-5000000/200000/20;
     *                      5000000-10000000/500000/10; 10000000-40000000/1000000/30; 40000000-80000000/1000600/25; 8000000以上;1
     * @return 脱敏后出行总里程区间
     */
    public static String divideSumFeeMileage(String sumFeeMileage) {
        String result = "E";
        long feeMileage = Long.parseLong(sumFeeMileage.split("\\.")[0]);
        if (feeMileage < 200000) {
            result = result + (feeMileage / 50000 + 1);
        } else if (feeMileage < 1000000) {
            result = result + ((feeMileage - 200000) / 100000 + 1 + 4);
        } else if (feeMileage < 5000000) {
            result = result + ((feeMileage - 1000000) / 200000 + 1 + 4 + 8);
        } else if (feeMileage < 10000000) {
            result = result + ((feeMileage - 5000000) / 500000 + 1 + 4 + 8 + 20);
        } else if (feeMileage < 40000000) {
            result = result + ((feeMileage - 10000000) / 1000000 + 1 + 4 + 8 + 20 + 10);
        } else if (feeMileage < 80000000) {
            result = result + ((feeMileage - 40000000) / 1600000 + 1 + 4 + 8 + 20 + 10 + 30);
        } else {
            result = result + (1 + 4 + 8 + 20 + 10 + 30 + 25);
        }
        return result;
    }

    /**
     * 负重出行总里程
     *
     * @param sumWeightMileage 0/1; 0-200000/50000/4; 200000-1000000/100000/8; 1000000-5000000/200000/20;
     *                         5000000-10000000/500000/10; 10000000-40000000/1000000/30; 40000000-80000000/1600000/25;
     *                         80000000以上/1
     * @return 脱敏后负重出行总里程区间
     */
    public static String divideSumWeightMileage(String sumWeightMileage) {
        String result = "F";
        long weightMileage = Long.parseLong(sumWeightMileage.split("\\.")[0]);
        if (weightMileage == 0) {
            result = result + "0";
            return result;
        }
        weightMileage = weightMileage - 1;
        if (weightMileage <= 200000) {
            result = result + (weightMileage / 50000 + 1);
        } else if (weightMileage <= 1000000) {
            result = result + ((weightMileage - 200000) / 100000 + 1 + 4);
        } else if (weightMileage <= 5000000) {
            result = result + ((weightMileage - 1000000) / 200000 + 1 + 4 + 8);
        } else if (weightMileage <= 10000000) {
            result = result + ((weightMileage - 5000000) / 500000 + 1 + 4 + 8 + 20);
        } else if (weightMileage <= 40000000) {
            result = result + ((weightMileage - 10000000) / 1000000 + 1 + 4 + 8 + 20 + 10);
        } else if (weightMileage <= 80000000) {
            result = result + ((weightMileage - 40000000) / 1600000 + 1 + 4 + 8 + 20 + 10 + 30);
        } else {
            result = result + (1 + 1 + 4 + 8 + 20 + 10 + 30 + 25);
        }
        return result;
    }
}
